<template>
  <p
    v-if="!edit && !loading"
    :class="['InputText', props.class]"
    :title="props.label"
  >
    {{ value }}
  </p>

  <PSkeleton
    v-if="loading"
    :class="['InputText', 'InputText__Skeleton', props.class]"
  />

  <div v-if="edit && !loading">
    <label>
      <span class="InputText__Label">{{ props.label }}</span>
      <PInputText
        v-model="value"
        class="InputText__Input"
        type="text"
        maxlength="255"
        :placeholder="props.label"
      />
    </label>
    <ErrorWrapper :errors="props.errors" />
  </div>
</template>

<script lang="ts" setup>
import { computed } from 'vue'
import { FieldErrors } from '@/components/form/validation'

const props = withDefaults(
  defineProps<{
    label: string
    class?: string
    modelValue: string
    edit?: boolean
    loading?: boolean
    errors?: FieldErrors
  }>(),
  {
    class: '',
    modelValue: '',
    edit: false,
    loading: false,
    errors: () => [],
  }
)

const emit = defineEmits<{
  (e: 'update:modelValue', value: string | null): void
}>()

const value = computed<string | null>({
  get: () => props.modelValue,
  set: (value: string | null) => emit('update:modelValue', value || null),
})
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.InputText {
  &__Skeleton {
    margin: v.$spacing 0;
  }

  &__Label {
    position: relative;
    left: 8px;
    color: var(--secondary-color);
    font-size: 0.8em;
    line-height: 0.8em;
  }

  &__Input {
    display: block;
    width: 100%;
  }
}
</style>
